<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: Thread::Hdlc::Encoder::BufferWriteIterator Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="../../annotated.html"><span>Classes</span></a></li>
      <li><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="../../classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="../../inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="../../functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="../../dc/dbc/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Thread::Hdlc::Encoder::BufferWriteIterator Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This class defines a write iterator into a buffer used by <a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html" title="This class implements the HDLC-lite encoder. ">Encoder</a>.  
 <a href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">src/ncp/hdlc.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a95fa42af34764041edf8901860560833"><td class="memItemLeft" align="right" valign="top"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a95fa42af34764041edf8901860560833">WriteByte</a> (uint8_t aByte)</td></tr>
<tr class="memdesc:a95fa42af34764041edf8901860560833"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method writes a byte to the buffer and updates the iterator (if space is available).  <a href="#a95fa42af34764041edf8901860560833">More...</a><br /></td></tr>
<tr class="separator:a95fa42af34764041edf8901860560833"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d6d63d2b1855c2a1dd6deb536ebf702"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a8d6d63d2b1855c2a1dd6deb536ebf702">CanWrite</a> (uint16_t aWriteLength) const </td></tr>
<tr class="memdesc:a8d6d63d2b1855c2a1dd6deb536ebf702"><td class="mdescLeft">&#160;</td><td class="mdescRight">This method checks if there is buffer space available to write <code>aWriteLength</code> bytes.  <a href="#a8d6d63d2b1855c2a1dd6deb536ebf702">More...</a><br /></td></tr>
<tr class="separator:a8d6d63d2b1855c2a1dd6deb536ebf702"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a632b4b6993d4fc6d728d4f92a15a00e5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a632b4b6993d4fc6d728d4f92a15a00e5"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a632b4b6993d4fc6d728d4f92a15a00e5">BufferWriteIterator</a> (void)</td></tr>
<tr class="memdesc:a632b4b6993d4fc6d728d4f92a15a00e5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Protected constructor to ensure no direct instantiation. <br /></td></tr>
<tr class="separator:a632b4b6993d4fc6d728d4f92a15a00e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a8ab73d4caf519d3471850604f961b61c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ab73d4caf519d3471850604f961b61c"></a>
uint8_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#a8ab73d4caf519d3471850604f961b61c">mWritePointer</a></td></tr>
<tr class="memdesc:a8ab73d4caf519d3471850604f961b61c"><td class="mdescLeft">&#160;</td><td class="mdescRight">A pointer to current write position in the buffer. <br /></td></tr>
<tr class="separator:a8ab73d4caf519d3471850604f961b61c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6656a54afdb95004b9cdd92d93b670d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad6656a54afdb95004b9cdd92d93b670d"></a>
uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html#ad6656a54afdb95004b9cdd92d93b670d">mRemainingLength</a></td></tr>
<tr class="memdesc:ad6656a54afdb95004b9cdd92d93b670d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of remaining bytes available to write. <br /></td></tr>
<tr class="separator:ad6656a54afdb95004b9cdd92d93b670d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class defines a write iterator into a buffer used by <a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html" title="This class implements the HDLC-lite encoder. ">Encoder</a>. </p>
<p><a class="el" href="../../d5/d0a/namespaceThread_1_1Hdlc.html" title="This namespace includes definitions for the HDLC-lite encoder and decoder. ">Hdlc</a> users should sub-class this to add the actual buffer space. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a8d6d63d2b1855c2a1dd6deb536ebf702"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Thread::Hdlc::Encoder::BufferWriteIterator::CanWrite </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>aWriteLength</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method checks if there is buffer space available to write <code>aWriteLength</code> bytes. </p>
<p>param[in] aWriteLength Number of bytes to write.</p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">true</td><td>Enough buffer space available to write the requested number of bytes. </td></tr>
    <tr><td class="paramname">false</td><td>Insufficient buffer space to write the requested number of bytes. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a8d6d63d2b1855c2a1dd6deb536ebf702_icgraph.png" border="0" usemap="#db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a8d6d63d2b1855c2a1dd6deb536ebf702_icgraph" alt=""/></div>
<map name="db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a8d6d63d2b1855c2a1dd6deb536ebf702_icgraph" id="db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a8d6d63d2b1855c2a1dd6deb536ebf702_icgraph">
<area shape="rect" id="node2" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a89f6e268087e2fa6c1303f4566c131ed" title="This method encodes a single byte into a buffer at aIterator. " alt="" coords="208,68,363,107"/>
<area shape="rect" id="node3" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a1dd8633eefe3efb8f8cf4eca28e61f4a" title="This method encodes the frame into a buffer at aIterator. " alt="" coords="411,5,566,44"/>
<area shape="rect" id="node4" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a5513b8590576eb7008068fd953ad7ba7" title="This method finalizes an HDLC frame. " alt="" coords="411,68,566,107"/>
<area shape="rect" id="node5" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="614,97,799,136"/>
</map>
</div>
</p>

</div>
</div>
<a class="anchor" id="a95fa42af34764041edf8901860560833"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../dc/dbf/openthread-types_8h.html#ab701d053a9c34ab7f11e43e0dc09ac9f">ThreadError</a> Thread::Hdlc::Encoder::BufferWriteIterator::WriteByte </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>aByte</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This method writes a byte to the buffer and updates the iterator (if space is available). </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">kThreadError_None</td><td>Successfully wrote the byte and updates the iterator. </td></tr>
    <tr><td class="paramname">kThreadError_NoBufs</td><td>Insufficient buffer space. </td></tr>
  </table>
  </dd>
</dl>

<p><div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a95fa42af34764041edf8901860560833_icgraph.png" border="0" usemap="#db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a95fa42af34764041edf8901860560833_icgraph" alt=""/></div>
<map name="db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a95fa42af34764041edf8901860560833_icgraph" id="db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator_a95fa42af34764041edf8901860560833_icgraph">
<area shape="rect" id="node2" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#ab46533056028094a64768d238ad99a4c" title="This method begins an HDLC frame and puts the initial bytes into a buffer at the given aIterator..." alt="" coords="208,5,363,44"/>
<area shape="rect" id="node4" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a89f6e268087e2fa6c1303f4566c131ed" title="This method encodes a single byte into a buffer at aIterator. " alt="" coords="208,91,363,129"/>
<area shape="rect" id="node6" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a5513b8590576eb7008068fd953ad7ba7" title="This method finalizes an HDLC frame. " alt="" coords="411,153,566,192"/>
<area shape="rect" id="node3" href="../../dc/d60/classThread_1_1NcpUart.html#a8398d715de6960bf6257d93ac81dfa3a" title="This method finalizes and sends the current outbound frame. " alt="" coords="614,33,799,72"/>
<area shape="rect" id="node5" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html#a1dd8633eefe3efb8f8cf4eca28e61f4a" title="This method encodes the frame into a buffer at aIterator. " alt="" coords="411,91,566,129"/>
</map>
</div>
</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/ncp/<a class="el" href="../../d1/d75/hdlc_8hpp_source.html">hdlc.hpp</a></li>
<li>src/ncp/<a class="el" href="../../d5/d02/hdlc_8cpp.html">hdlc.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><b>Thread</b></li><li class="navelem"><a class="el" href="../../d5/d0a/namespaceThread_1_1Hdlc.html">Hdlc</a></li><li class="navelem"><a class="el" href="../../d4/d27/classThread_1_1Hdlc_1_1Encoder.html">Encoder</a></li><li class="navelem"><a class="el" href="../../db/d9c/classThread_1_1Hdlc_1_1Encoder_1_1BufferWriteIterator.html">BufferWriteIterator</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:36 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
